import { AllowedComponentProps } from 'vue';
import { App } from 'vue';
import { ComponentCustomProps } from 'vue';
import { ComponentOptionsMixin } from 'vue';
import { DefineComponent } from 'vue';
import { ExtractPropTypes } from 'vue';
import { fitType } from '@v2v/pdf';
import { MatchInfos } from '@v2v/pdf';
import { PropType } from 'vue';
import { Ref } from 'vue';
import { RenderType } from '@v2v/pdf';
import { VNodeProps } from 'vue';

export declare const APdf: DefineComponent<{
    loadingText: {
        type: StringConstructor;
        default: string;
    };
    loadingTextColor: {
        type: StringConstructor;
        default: string;
    };
    loadingSize: {
        type: NumberConstructor;
        default: number;
    };
    showLoading: {
        type: BooleanConstructor;
        default: boolean;
    };
    workerSrc: {
        type: StringConstructor;
    };
    renderTextLayer: {
        type: BooleanConstructor;
        default: boolean;
    };
    loadAll: {
        type: BooleanConstructor;
        default: boolean;
    };
    page: {
        type: NumberConstructor;
        default: number;
    };
    fitType: {
        type: PropType<fitType>;
        default: string;
    };
    scale: {
        type: NumberConstructor;
        default: number;
    };
    url: {
        type: StringConstructor;
        required: true;
    };
}, {
    getTotal: typeof getTotal;
    getVPdfRef: typeof getVPdfRef;
}, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {}, string, VNodeProps & AllowedComponentProps & ComponentCustomProps, Readonly<ExtractPropTypes<{
    loadingText: {
        type: StringConstructor;
        default: string;
    };
    loadingTextColor: {
        type: StringConstructor;
        default: string;
    };
    loadingSize: {
        type: NumberConstructor;
        default: number;
    };
    showLoading: {
        type: BooleanConstructor;
        default: boolean;
    };
    workerSrc: {
        type: StringConstructor;
    };
    renderTextLayer: {
        type: BooleanConstructor;
        default: boolean;
    };
    loadAll: {
        type: BooleanConstructor;
        default: boolean;
    };
    page: {
        type: NumberConstructor;
        default: number;
    };
    fitType: {
        type: PropType<fitType>;
        default: string;
    };
    scale: {
        type: NumberConstructor;
        default: number;
    };
    url: {
        type: StringConstructor;
        required: true;
    };
}>>, {
    scale: number;
    fitType: fitType;
    loadingText: string;
    loadingTextColor: string;
    loadingSize: number;
    showLoading: boolean;
    renderTextLayer: boolean;
    loadAll: boolean;
    page: number;
}, {}>;

export declare interface config {
    loadAll: boolean;
    page: number;
    workerSrc?: string;
}

declare const _default: {
    install(app: App): void;
};
export default _default;

declare function getTotal(): number;

declare function getVPdfRef(): null;

export declare type lastScaleType = 'scale' | 'fit' | null;

export declare interface queryProps {
    highlight: boolean;
    match: MatchInfos[];
    uniqueId?: string;
}

export declare function setPdfWorkerSrc(url?: string): void;

export declare function usePdf({ pdfContainer, query, url, config }: usePdfProps): {
    loading: Ref<boolean>;
    total: Ref<number>;
    render: (config: {
        pageNum?: number;
        renderType?: RenderType;
        fitType?: fitType;
        scale?: number;
        lastScaleType?: lastScaleType;
    }) => Promise<{
        time: number;
        text: string;
        generateHightLight: (data: MatchInfos[], uniqueId: string) => void;
        total?: number | undefined;
    } | null | undefined>;
    setMode: (type: fitType) => void;
    vPdf: null;
    setScale: (scale: number) => void;
};

export declare interface usePdfProps {
    url: string;
    pdfContainer: string | HTMLDivElement | Ref<HTMLDivElement | null>;
    query?: queryProps;
    config?: config;
}

export { }
